<?php
  //Returns a user info array containing information about the current user
  //returns if they are logged in, if they are admin and what their name is
  function logged_in_user(){
    $info = array("logged_in" => false, "admin" => false, "name" => "");
    if(isset($_SESSION["user"])){
      $info["logged_in"] = true;
      $user = get_user($_SESSION["user"]);
      if($user["role"] == "admin") $info["admin"] = true;
      $info["name"] = $_SESSION["user"];
    }
    return $info;
  }
  
  //Returns a list of all users in the user database
  function get_users(){
    global $DB;
    $users = array();
    $fp = fopen($DB["file"], "r");
    $contents = fread($fp, filesize($DB["file"]));
    fclose($fp);
    $contents = explode("\r\n", $contents);
    foreach($contents as $item){
      $item = explode($DB["delimiter"], $item);
      array_push($users, array("name" => stripslashes($item[0]), "pass" => stripslashes($item[1]), "role" => stripslashes($item[2]))); 
    }
    return $users;
  }
  
  //Returns information about a particular user
  function get_user($name){
    $users = get_users();
    foreach($users as $user){
      if($user["name"] == $name) return $user; 
    }
    return array("name" => "", "pass" => "", "role" => "");
  }
  
  //Checks to see if the username and password entered are a match to a user
  function check_user($username, $password){
    $usr = get_user($username);
    if($usr["name"] != ""){
      if($usr["name"] == $username && $usr["pass"] == $password){
        return true;
      }else{
        return false;
      }
    }else{
      return false;
    }
  }
  
  //Checks to see if a user exists
  function user_exists($username){
    return get_user($username) != array("name" => "", "pass" => "", "role" => "");
  }
  
  //Starts the session
  session_start();
  //Gets current user information, mostly blank if not logged in
  $CURRENT_USER = logged_in_user();
?>