<?php
//Include global includes
include("includes/global.php");

//If current user is not logged in, go back to the index.php
if(!$CURRENT_USER["logged_in"]){
  header("location: index.php");
  exit();
}

//If an upload was sent to the server
if(isset($_FILES["file"])) {
  //Work out target directory
  $targetDir = "uploads/".sha1($CURRENT_USER["name"].$FOLDERS["UserSalt"])."/".sha1(uniqid('', true).$FOLDERS["FileSalt"])."/";
  //Work out target file
  $targetFile = $targetDir . basename($_FILES["file"]["name"]);
  //Work out file extension
  $fileExt = pathinfo($targetFile, PATHINFO_EXTENSION);
  //If file already exists
  if (file_exists($targetFile)) {
    header("location: upload.php?r=1"); //We have an error redirect
    exit();
  }
  //Get usage info
  $usage_info = get_used_space($CURRENT_USER);
  //Get maximum file size
  $max_size = $FOLDERS["MaxFileSize"];
  //If the upload would take us past the maximum space usage
  if($FOLDERS["MaxStorageSize"] - $usage_info["size"] < $max_size){
    $max_size = $FOLDERS["MaxStorageSize"] - $usage_info["size"];
  }
  //If file is not greater than the maximum file size
  if($_FILES["file"]["size"] > $max_size || $_FILES["file"]["error"] == 1) {
    header("location: upload.php?r=2");
    exit();
  }
  //Make the target directory
  if(!mkdir($targetDir, 0777, true)){
    header("location: upload.php?r=3"); //If the directory can't be made, redirect with error
    exit();
  }
  /*
    / No need to secure this any more as the other method used to       /
    / download files protects us from Remote Code Execution via uploads /
    if($fileExt != "txt" || $fileExt != "txt" || $fileExt != "txt" || $fileExt != "txt"){
    $failure = 3
  }*/
  //Try and move the uploaded file
  if(move_uploaded_file($_FILES["file"]["tmp_name"], $targetFile)){
    header("location: upload.php?r=0"); //If there was no error redirect
    exit();
  }else{
    header("location: upload.php?r=4"); //If there was an error redirect with error
    exit();
  }
}
?>